TOOLCHAIN = mips64-nlm-linux

CC = $(TOOLCHAIN)-gcc
LD = $(TOOLCHAIN)-ld
OBJCOPY = $(TOOLCHAIN)-objcopy
OBJDUMP = $(TOOLCHAIN)-objdump
AR = $(TOOLCHAIN)-ar
NM = $(TOOLCHAIN)-nm

xenoprof := n

#
# If you change any of these configuration options then you must
# 'make clean' before rebuilding.
#
supervisor_mode_kernel ?= n

# Solaris grabs stdarg.h and friends from the system include directory.
ifneq ($(XEN_OS),SunOS)
CFLAGS += -nostdinc
endif

CFLAGS += -fno-builtin -fno-common
CFLAGS += -iwithprefix include -Werror -Wno-pointer-arith -pipe
CFLAGS += -I$(BASEDIR)/include 
CFLAGS += -I$(BASEDIR)/include/asm-mips/mach-generic
CFLAGS += -I$(BASEDIR)/include/asm-mips/mach-default

# Prevent floating-point variables from creeping into Xen.
CFLAGS += -msoft-float

# Disable PIE/SSP if GCC supports them. They can break us.
$(call cc-option-add,CFLAGS,CC,-nopie)
$(call cc-option-add,CFLAGS,CC,-fno-stack-protector)
$(call cc-option-add,CFLAGS,CC,-fno-stack-protector-all)

ifeq ($(supervisor_mode_kernel),y)
CFLAGS += -DCONFIG_MIPS_SUPERVISOR_MODE_KERNEL=1
endif

# Require GCC v3.4+ (to avoid issues with alignment constraints in Xen headers)
$(call cc-ver-check,CC,0x030400,"Xen requires at least gcc-3.4")

CFLAGS += -I$(FDT_DIR)/libfdt
export FDT_DIR
