#include <xen/config.h>
#include <asm/asm.h>
#include <asm/irqflags.h>
#include <asm/regdef.h>
#include <asm/page.h>
#include <asm/mipsregs.h>
#include <asm/stackframe.h>
#include <asm/asm-offsets.h>

       .section ".text","ax"

NESTED(except_vec_generic, 0, sp)
    mfc0    k1, CP0_CAUSE
    dla     k0, exception_handlers
    andi    k1, k1, 0x7c
#if (_MIPS_SIM == MIPS_SIM_ABI64)
    sll     k1, k1, 1
#endif
    addu    k0, k0, k1
    PTR_L   k0, (k0)
    jr      k0
    nop
END(except_vec_generic)


.section ".text","ax"
    .align  5
NESTED(handle_int, PT_SIZE, sp)
	.set    push
	mfc0	k0, CP0_STATUS
	and	k0, ST0_IE
	bnez	k0, 1f
	eret
1:	.set pop
    SAVE_ALL
	CLI
	LONG_L	s0, TI_REGS($28)
	LONG_S	sp, TI_REGS($28)
	PTR_LA	ra, ret_from_irq
	j	plat_irq_dispatch
	END(handle_int)

    .align  4
NESTED(handle_reserved, PT_SIZE, sp)
    .set    noat
    .set noreorder
	wait
1:	b	1b
	nop
	nop
END(handle_reserved)
