#include <xen/config.h>
#include <asm/asm.h>
#include <asm/asmmacro.h>
#include <asm/irqflags.h>
#include <asm/regdef.h>
#include <asm/page.h>
#include <asm/mipsregs.h>
#include <asm/stackframe.h>
		
	/*
	 * Reserved space for exception handlers.
	 * Necessary for machines which link their kernels at KSEG0.
	 */
	.fill	0x400

EXPORT(stext)					# used for profiling
EXPORT(_stext)

#ifdef CONFIG_MIPS_SIM
	/*
	 * Give us a fighting chance of running if execution beings at the
	 * kernel load address.  This is needed because this platform does
	 * not have a ELF loader yet.
	 */
	j	kernel_entry
#endif

NESTED(xen_entry, 16, sp)			# kernel entry point

	setup_c0_status_pri

	PTR_LA		t0, __bss_start		# clear .bss
	LONG_S		zero, (t0)
	PTR_LA		t1, __bss_stop - LONGSIZE
1:
	PTR_ADDIU	t0, LONGSIZE
	LONG_S		zero, (t0)
	bne		t0, t1, 1b

	LONG_S		a0, fw_arg0		# firmware arguments
	LONG_S		a1, fw_arg1
	LONG_S		a2, fw_arg2
	LONG_S		a3, fw_arg3

	MTC0		zero, CP0_CONTEXT	# clear context register

	/*
	 * setup the initial stack and task/thread structure
	 */
	PTR_LA		$28, init_thread_union
	PTR_LI		sp, _THREAD_SIZE - 64
	PTR_ADDU	sp, $28

	set_saved_sp	sp, t0, t1
	PTR_SUBU	    sp, 4 * SZREG		# init stack pointer

	PTR_LA $8, __start_xen	
	jr   $8		
	END(xen_entry)

#ifdef CONFIG_QEMU
	__INIT
#endif
