/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1999, 2000 by Silicon Graphics
 * Copyright (C) 2003 by Ralf Baechle
 */
#include <xen/config.h>
#include <xen/init.h>
#include <xen/mm.h>
#include <asm/pgtable.h>
#include <asm/pgalloc.h>

#ifdef CONFIG_XEN_2LEVEL_PGTABLE
#define INVALID_PGD_PTR invalid_pte_table
#else
#define INVALID_PGD_PTR invalid_pmd_table
#endif

void pgd_init(unsigned long page)
{
	unsigned long *p, *end;

 	p = (unsigned long *) page;
	end = p + PTRS_PER_PGD;

	while (p < end) {
		p[0] = (unsigned long) INVALID_PGD_PTR;
		p[1] = (unsigned long) INVALID_PGD_PTR;
		p[2] = (unsigned long) INVALID_PGD_PTR;
		p[3] = (unsigned long) INVALID_PGD_PTR;
		p[4] = (unsigned long) INVALID_PGD_PTR;
		p[5] = (unsigned long) INVALID_PGD_PTR;
		p[6] = (unsigned long) INVALID_PGD_PTR;
		p[7] = (unsigned long) INVALID_PGD_PTR;
		p += 8;
	}
}

void pmd_init(unsigned long page)
{
	unsigned long *p, *end;

 	p = (unsigned long *) page;
	end = p + PTRS_PER_PMD;

	while (p < end) {
		p[0] = (unsigned long) invalid_pte_table;
		p[1] = (unsigned long) invalid_pte_table;
		p[2] = (unsigned long) invalid_pte_table;
		p[3] = (unsigned long) invalid_pte_table;
		p[4] = (unsigned long) invalid_pte_table;
		p[5] = (unsigned long) invalid_pte_table;
		p[6] = (unsigned long) invalid_pte_table;
		p[7] = (unsigned long) invalid_pte_table;
		p += 8;
	}
}

void pte_init(unsigned long page)
{
	unsigned long *p, *end;

 	p = (unsigned long *) page;
	end = p + PTRS_PER_PTE;

	while (p < end) {
		p[0] = (unsigned long) 0;
		p[1] = (unsigned long) 0;
		p[2] = (unsigned long) 0;
		p[3] = (unsigned long) 0;
		p[4] = (unsigned long) 0;
		p[5] = (unsigned long) 0;
		p[6] = (unsigned long) 0;
		p[7] = (unsigned long) 0;
		p += 8;
	}
}
