/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1997, 98, 99, 2000, 01, 05 Ralf Baechle (ralf@linux-mips.org)
 * Copyright (C) 1999, 2000 Silicon Graphics, Inc.
 * Copyright (C) 2001 MIPS Technologies, Inc.
 */
#ifndef _ASM_HARDIRQ_H
#define _ASM_HARDIRQ_H

#include <xen/threads.h>
#include <xen/cache.h>
#include <asm/irq.h>

struct irq_cpustat {
	unsigned long __softirq_pending;
	unsigned long __local_irq_count;
	unsigned long __nmicount;
} ____cacheline_aligned;

typedef struct irq_cpustat irq_cpustat_t;

#include <xen/irq_cpustat.h>	/* Standard mappings for irq_cpustat_t above */

#define in_irq() (local_irq_count(smp_processor_id()) != 0)

#define irq_enter()     (local_irq_count(smp_processor_id())++)

extern void ack_bad_irq(unsigned int irq);
extern void irq_exit(void);
extern int init_IRQ(void);

#endif /* _ASM_HARDIRQ_H */
