#ifndef _ASM_NETL_XLP_PIC_H
#define _ASM_NETL_XLP_PIC_H

#define PIC_CLKS_PER_SEC 133333333ULL
#define PIC_CLKS_PER_USEC 133	/* (PIC_CLKS_PER_SEC / 1000000) */
#define PIC_CLKS_PER_TIMER_TICK (PIC_CLKS_PER_SEC / HZ)

/* IRT Map */
#define PIC_NUM_IRTS               160

#define PIC_IRT_WD_0_INDEX         0
#define PIC_IRT_WD_1_INDEX         1
#define PIC_IRT_WD_NMI_0_INDEX     2
#define PIC_IRT_WD_NMI_1_INDEX     3
#define PIC_IRT_TIMER_0_INDEX      4
#define PIC_IRT_TIMER_1_INDEX      5
#define PIC_IRT_TIMER_2_INDEX      6
#define PIC_IRT_TIMER_3_INDEX      7
#define PIC_IRT_TIMER_4_INDEX      8
#define PIC_IRT_TIMER_5_INDEX      9
#define PIC_IRT_TIMER_6_INDEX      10
#define PIC_IRT_TIMER_7_INDEX      11
#define PIC_IRT_CLOCK_INDEX        PIC_IRT_TIMER_7_INDEX

#define PIC_NUM_MSG_Q_IRTS         32
#define PIC_IRT_MSG_Q0_INDEX       12
#define PIC_IRT_MSG_Q_INDEX(qid)   ((qid) + PIC_IRT_MSG_Q0_INDEX) // 12 - 43

#define PIC_NUM_NA_IRTS            32
#define PIC_IRT_NA_0_INDEX         44
#define PIC_IRT_NA_INDEX(num)      ((num) + PIC_IRT_NA_0_INDEX) // 44 - 75

#define PIC_NUM_PCIE_MSIX_IRTS     32
#define PIC_IRT_PCIE_MSIX_0_INDEX  12
#define PIC_IRT_PCIE_MSIX_INDEX(num) ((num) + PIC_IRT_PCIE_MSIX_0_INDEX) // 76 - 107

#define PIC_NUM_PCIE_LINK_IRTS     4
#define PIC_IRT_PCIE_LINK_0_INDEX  108
#define PIC_IRT_PCIE_LINK_INDEX(num) ((num) + PIC_IRT_PCIE_LINK_0_INDEX) // 108 - 111

#define PIC_NUM_USB_IRTS           6
#define PIC_IRT_USB_0_INDEX          112
#define PIC_IRT_USB_INDEX(num) ((num) + PIC_IRT_USB_0_INDEX) // 112 - 117

#define PIC_IRT_POE_INDEX          118
#define PIC_IRT_GDX_INDEX          119
#define PIC_IRT_SEC_INDEX          120

#define PIC_NUM_COMP_IRTS          4
#define PIC_IRT_COMP_0_INDEX       121
#define PIC_IRT_COMP_INDEX(num)    ((num) + PIC_IRT_COMP_0_INDEX) // 121 - 124

#define PIC_IRT_GBU_INDEX          125
#define PIC_IRT_ICC_0_INDEX        126 // ICC - Inter Chip Coherency
#define PIC_IRT_ICC_1_INDEX        127
#define PIC_IRT_ICC_2_INDEX        128
#define PIC_IRT_GBC_INDEX          129 // GBC - Global Coherency
#define PIC_IRT_MSG_0_INDEX        130
#define PIC_IRT_MSG_1_INDEX        131
#define PIC_IRT_CAM_INDEX          132
#define PIC_IRT_UART_0_INDEX       133
#define PIC_IRT_UART_1_INDEX       134
#define PIC_IRT_I2C_0_INDEX        135
#define PIC_IRT_I2C_1_INDEX        136
#define PIC_IRT_GPIO_INDEX         137
#define PIC_IRT_PWR_MGMT_INDEX     138
#define PIC_IRT_JTAG_INDEX         139
#define PIC_IRT_RSA_INDEX          140
#define PIC_IRT_PIC                141
#define PIC_IRT_RESERVED           142 // 142 - 159
/*
 *     Register Offsets
 */
#define PIC_CTRL             0x00
#define PIC_BYTESWAP         0x01
#define PIC_STATUS           0x02
#define PIC_INT_TIMEOUT      0x03
#define PIC_ICI0_INT_TIMEOUT 0x04
#define PIC_ICI1_INT_TIMEOUT 0x05
#define PIC_ICI2_INT_TIMEOUT 0x06
#define PIC_IPI_CTL          0x07
#define PIC_INT_ACK          0x08
#define PIC_INT_PENDING0     0x09
#define PIC_INT_PENDING1     0x0a
#define PIC_INT_PENDING2     0x0b

#define PIC_WD0_MAX_VAL      0x0c
#define PIC_WD0_COUNT        0x0d
#define PIC_WD0_MASK_0       0x0e
#define PIC_WD0_MASK_1       0x0f
#define PIC_WD0_HEARBEATCMD  0x10
#define PIC_WD0_HEARBEAT_0   0x11
#define PIC_WD0_HEARBEAT_1   0x12

#define PIC_WD_MAX_VAL(id)    (PIC_WD0_MAX_VAL + ((id) ? 7 : 0))
#define PIC_WD_COUNT(id)      (PIC_WD0_COUNT + ((id) ? 7 : 0))
#define PIC_WD_MASK_0(id)     (PIC_WD0_MASK_0 + ((id) ? 7 : 0))  
#define PIC_WD_MASK_1(id)     (PIC_WD0_MASK_1 + ((id) ? 7 : 0))   
#define PIC_WD_HEARBEAT_0(id) (PIC_WD0_HEARTBEAT_0 + ((id) ? 7 : 0))
#define PIC_WD_HEARBEAT_1(id) (PIC_WD0_HEARTBEAT_1 + ((id) ? 7 : 0))

#define PIC_SYS_TIMER_0_MAX_VAL   0x1a
#define PIC_SYS_TIMER_MAX_VAL(id) (PIC_SYS_TIMER_0_MAX_VAL + (id))

#define PIC_SYS_TIMER_0_COUNTER   0x22
#define PIC_SYS_TIMER_COUNTER(id) (PIC_SYS_TIMER_0_COUNTER + (id)) 

#define PIC_TIMER_0_MAXVAL   PIC_SYS_TIMER_0_MAX_VAL
#define PIC_TIMER_0_COUNTER  PIC_SYS_TIMER_0_COUNTER
#define PIC_TIMER_7_MAXVAL   PIC_SYS_TIMER_MAX_VAL(7)
#define PIC_TIMER_7_COUNTER  PIC_SYS_TIMER_COUNTER(7)
#define PIC_TIMER_6_MAXVAL   PIC_SYS_TIMER_MAX_VAL(6)
#define PIC_TIMER_6_COUNTER  PIC_SYS_TIMER_COUNTER(6)

#define PIC_INT_THR_ENABLE_0_N01   0x2a
#define PIC_INT_THR_ENABLE_0_N23   0x2b
#define PIC_INT_THR_ENABLE_N01(id) (PIC_INT_THR_ENABLE_0_N12 + ((id) * 2))
#define PIC_INT_THR_ENABLE_N23(id) (PIC_INT_THR_ENABLE_0_N12 + ((id) * 2))

#define PIC_IRT_0   0x3a
#define PIC_IRT(id) (PIC_IRT_0 + (id))

#define PIC_IRT_WD_0        PIC_IRT(PIC_IRT_WD0_INDEX)
#define PIC_IRT_WD_1        PIC_IRT(PIC_IRT_WD1_INDEX)
#define PIC_IRT_TIMER_0     PIC_IRT(PIC_IRT_TIMER_0_INDEX)
#define PIC_IRT_TIMER_1     PIC_IRT(PIC_IRT_TIMER_1_INDEX)
#define PIC_IRT_TIMER_2     PIC_IRT(PIC_IRT_TIMER_2_INDEX)
#define PIC_IRT_TIMER_3     PIC_IRT(PIC_IRT_TIMER_3_INDEX)
#define PIC_IRT_TIMER_4     PIC_IRT(PIC_IRT_TIMER_4_INDEX)
#define PIC_IRT_TIMER_5     PIC_IRT(PIC_IRT_TIMER_5_INDEX)
#define PIC_IRT_TIMER_6     PIC_IRT(PIC_IRT_TIMER_6_INDEX)
#define PIC_IRT_TIMER_7     PIC_IRT(PIC_IRT_TIMER_7_INDEX)
#define PIC_IRT_CLOCK       PIC_IRT_TIMER_7
#define PIC_IRT_UART_0      PIC_IRT(PIC_IRT_UART_0_INDEX)
#define PIC_IRT_UART_1      PIC_IRT(PIC_IRT_UART_1_INDEX)
#define PIC_IRT_I2C_0       PIC_IRT(PIC_IRT_I2C_0_INDEX)
#define PIC_IRT_I2C_1       PIC_IRT(PIC_IRT_I2C_1_INDEX)

#define PIC_CLOCK_TIMER     7
#define PIC_IRQ_BASE        8
//extern int printk(const char * fmt, ...); 

#define ASM_XLP_IO_PIC_OFFSET        0xffffffffb8004100 /* TODO: This will change in to function */
#define C_XLP_IO_PIC_OFFSET        0xffffffffb8004100ULL /* TODO: This will change in to function */

#ifndef __ASSEMBLY__
enum {
	WD0 = 0,
	WD1 = 1
};

static __inline__ int irt_to_irq(int irt_num)
{
	switch (irt_num) {
	case 0:  // watchdog 0
		return 8;

	case 4:  // Timer 0
		return 14;

	case 10: // Timer 6
		return 15;

	case 11: // Timer 7
		return 16;

	case PIC_IRT_UART_0_INDEX:
		return 17;

	case PIC_IRT_UART_1_INDEX:
		return 18;

	default:
		return ((irt_num % 15) + 32);
	};
}
/* */
static __inline__ int irq_to_irt(int irq_num)
{
	if (irq_num < 8) {
		return irq_num;
	}
	switch (irq_num) {
	case 8:  // Watchdog 0
		return 0;

	case 14:  // Timer 0
		return 4;

	case 15: // Timer 6
		return 10;

	case 16: // Timer 7
		return 11;

	case 17:// Uart 0
		return PIC_IRT_UART_0_INDEX;

	case 18:// Uart 1
		return PIC_IRT_UART_1_INDEX;

	default:
		//    printk("%s default case irq_num %d\n", __FUNCTION__, irq_num);
		return 160;
	};
}
#define PIC_IRT_FIRST_IRQ        (PIC_IRQ_BASE)
#define PIC_WD_0_IRQ             irt_to_irq(PIC_IRT_WD_0_INDEX)
#define PIC_WD_1_IRQ             irt_to_irq(PIC_IRT_WD_1_INDEX)
#define PIC_TIMER_0_IRQ          irt_to_irq(PIC_IRT_TIMER_0_INDEX)
#define PIC_TIMER_1_IRQ          irt_to_irq(PIC_IRT_TIMER_1_INDEX)
#define PIC_TIMER_2_IRQ          irt_to_irq(PIC_IRT_TIMER_2_INDEX)
#define PIC_TIMER_3_IRQ          irt_to_irq(PIC_IRT_TIMER_3_INDEX)
#define PIC_TIMER_4_IRQ          irt_to_irq(PIC_IRT_TIMER_4_INDEX)
#define PIC_TIMER_5_IRQ          irt_to_irq(PIC_IRT_TIMER_5_INDEX)
#define PIC_TIMER_6_IRQ          irt_to_irq(PIC_IRT_TIMER_6_INDEX)
#define PIC_TIMER_7_IRQ          irt_to_irq(PIC_IRT_TIMER_7_INDEX)
#define PIC_CLOCK_IRQ            (PIC_TIMER_7_IRQ)
#define PIC_UART_0_IRQ           17
#define PIC_UART_1_IRQ           18
#define PIC_I2C_0_IRQ            irt_to_irq(PIC_IRT_I2C_0_INDEX)
#define PIC_I2C_1_IRQ            irt_to_irq(PIC_IRT_I2C_1_INDEX)
#define PIC_GPIO_IRQ             irt_to_irq(PIC_IRT_GPIO_INDEX)
#define PIC_IRT_LAST_IRQ_        (PIC_IRQ_BASE + PIC_NUM_IRTS - 1)
#define PIC_IRT_LAST_IRQ()       PIC_IRT_LAST_IRQ_

/*
 *   Misc
 */
#define IRT_VALID       	1       
#define LOCAL_SCHEDULING    1
#define GLOBAL_SCHEDULING   0
#define PIC_IRQ_IS_IRT(irq) ((irq >= PIC_IRT_FIRST_IRQ) && (irq <= PIC_IRT_LAST_IRQ_))
#define PIC_IRQ_IS_EDGE_TRIGGERED(irq) 0 // XLP interrupts are level triggered

#define XLP_IO_PIC_OFFSET        ((unsigned long)C_XLP_IO_PIC_OFFSET) /* TODO: This will change in to function */

typedef volatile unsigned long long pic_reg_t;

static __inline__ void pic_send_ipi(int nmi, int vec, int node, int cpu)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;
	
	unsigned long long ipi = (nmi << 31) | (vec << 20) | (node << 17) | (1 << (cpu & 0xf));
	if (cpu > 15)
		ipi |= 0x10000; // Setting bit 16 to select cpus 16-31
	
	write_register_dw(mmio, PIC_IPI_CTL, ipi);
}

static __inline__ unsigned long long pic_read_control(void)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;
	return read_register_dw(mmio, PIC_CTRL);
}

static __inline__ void pic_write_control(unsigned long long control)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;

	write_register_dw(mmio, PIC_CTRL, control);
}

static __inline__ void pic_update_control(unsigned long long control)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;

	write_register_dw(mmio, PIC_CTRL, (control | read_register_dw(mmio, PIC_CTRL)));
}

static __inline__ void ack_pic(int irt_num)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;
	write_register_dw(mmio, PIC_INT_ACK, irt_num);
	// Ack the Status register for Watchdog & System timers
	if (irt_num < 12) {
		write_register_dw(mmio, PIC_STATUS, (1 << irt_num));
	}
}

static __inline__ pic_reg_t pic_read_irt(int irt_num)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;
	return read_register_dw(mmio, PIC_IRT(irt_num));
}

static __inline__ void pic_write_irt(int irt_num, int en, int nmi, int sch, int vec, int dt, int db, int dte)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;
	unsigned long long val = (((en & 0x1) << 31) | ((nmi & 0x1) << 29) | ((sch & 0x1) << 28) |
							  ((vec & 0x3f) << 20) | ((dt & 0x1 ) << 19) | ((db & 0x7) << 16) |
							  (dte & 0xffff));
	write_register_dw(mmio, PIC_IRT(irt_num), val);
}

#define CPUIDBITS01(X) ((X) & 0x3)
#define CPUIDBIT2(X) ((X >> 2) & 0x1) 

static __inline__ void pic_write_irt_direct(int irt_num, int en, int nmi, int sch, int vec, int cpu)
{
	pic_write_irt(irt_num, en, nmi, sch, vec, 1, CPUIDBIT2(cpu), CPUIDBITS01(cpu));
	/* Does not support multi node support yet */
}

static __inline__ pic_reg_t pic_read_timer(int timer)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;

	return read_register_dw(mmio, PIC_SYS_TIMER_COUNTER(timer));
}

static __inline__ void pic_write_timer(int timer, pic_reg_t value)
{
	pic_reg_t *mmio = (pic_reg_t *) XLP_IO_PIC_OFFSET;

	write_register_dw(mmio, PIC_SYS_TIMER_COUNTER(timer), value);
}

#endif

#endif
