#ifndef __PUBLIC_ARCH_MIPS_MEMORY_H__
#define __PUBLIC_ARCH_MIPS_MEMORY_H__

#include <public/xen.h>

#define XENMEM_physmap_mfn_list   13

struct xen_physmap_mfn_list {
    /* Which domain to translate for? */
    domid_t domid;

    /* Length of list. */
    unsigned long nr_gpfns;

    /* List of GPFNs to translate. */
    XEN_GUEST_HANDLE(ulong) gpfn_list;

    /*
     * Output list to contain MFN translations. May be the same as the input
     * list (in which case each input GPFN is overwritten with the output MFN).
     */
    XEN_GUEST_HANDLE(ulong) mfn_list;
};
typedef struct xen_physmap_mfn_list xen_physmap_mfn_list_t;
DEFINE_XEN_GUEST_HANDLE(xen_physmap_mfn_list_t);

#endif
